<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- table client -->
    <v-row>
      <v-col cols="12" sm="12" md="12">
        <v-card>
          <v-container grid-list-xs>
            <v-card-title>
              <h1>Client</h1>
            </v-card-title>
            <div>
              <v-card-title>
                <v-btn
                  class="mr-1"
                  @click="dialog_client = true"
                  type="button"
                  color="#428bca"
                  small
                  dark
                  ><v-icon small class="pr-1">mdi-account-plus</v-icon>
                  Add Client
                </v-btn>
                <v-spacer></v-spacer>
                <v-text-field
                  v-model="search"
                  append-icon="mdi-magnify"
                  label="Search"
                  single-line
                  hide-details
                ></v-text-field>
              </v-card-title>
            </div>

            <v-data-table
              :headers="headers"
              :items="all_client"
              :search="search"
            >
              <template v-slot:item.token="{ item }">
                <v-textarea
                  name="input-7-1"
                  rows="3"
                  :value="item.token"
                ></v-textarea>
              </template>
            </v-data-table>
          </v-container>
        </v-card>
        <br />
      </v-col>
    </v-row>
    <!-- table client -->

    <!-- dialog_add_client -->
    <v-dialog v-model="dialog_client" max-width="500px" persistent>
      <v-card>
        <v-card-title
          class="headline"
          style="color: white; background: #428bca"
        >
          Add Client
        </v-card-title>
        <v-form ref="form_client">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    label="Client name"
                    v-model="form_client.client_name"
                    :rules="client_name_rules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    label="Note"
                    v-model="form_client.note"
                    outlined
                    dense
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancle_client()" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="submit_client()" style="color: white">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_add_client -->
  </v-app>
</template>

<script>
export default {
  data() {
    return {
      api: process.env.VUE_APP_API,
      dialog_loader: false,
      dialog_client: false,
      session_id: this.$cookies.get("info_login").session_id,
      form_client: {
        client_name: "",
        note: "",
      },
      client_name_rules: [(v) => !!v || "Please enter client name"],
      testingCode: "1234",
      data_client: "",
      headers: [
        { text: "Client_name", value: "client_name", width: "10%" },
        {
          text: "Client_id",
          align: "start",
          sortable: false,
          value: "client_id",
          width: "15%",
        },
        { text: "Ref_code", value: "ref_code", width: "15%" },
        { text: "Secret_key", value: "secret_key", width: "8%" },
        { text: "Token", value: "token", width: "20%" },
      ],
      search: "",
      all_client: [],
    };
  },
  mounted() {
    console.log("api -->", this.api);
    this.get_client();
  },
  methods: {
    get_client() {
      this.dialog_loader = true;
      let userlogId = this.$cookies.get("info_login").user_id;
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/client/geTClient", {
          params: {
            userlog_id: userlogId,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          this.dialog_loader = false;
          console.log(response);
          this.all_client = response.data.data;
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log(error);
        });
    },

    cancle_client() {
      this.$refs.form_client.reset();
      this.dialog_client = false;
    },

    submit_client() {
      if (!this.$refs.form_client.validate()) return;
      console.log("correct");
      console.log(this.form_client);
      this.dialog_loader = true;
      this.axios
        .post(
          process.env.VUE_APP_API + "/api/v3/client/creatEClient",
          this.form_client,
          {
            headers: {
              Authorization: this.session_id,
            },
          }
        )
        .then((response) => {
          this.dialog_loader = false;
          console.log("response", response.data.data);
          this.data_client = response.data.data;
          this.dialog_client = false;
          this.$swal({
            icon: "success",
            title: "Success!",
            text: response.data.message + ".",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.get_client();
            this.$refs.form_client.reset();
          });
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },
    copyTestingCode() {
      let testingCodeToCopy = document.querySelector("#testing-code");
      testingCodeToCopy.setAttribute("type", "text");
      testingCodeToCopy.select();

      try {
        var successful = document.execCommand("copy");
        var msg = successful ? "successful" : "unsuccessful";
        alert("Testing code was copied " + msg);
      } catch (err) {
        alert("Oops, unable to copy");
      }
      /* unselect the range */
      testingCodeToCopy.setAttribute("type", "hidden");
      window.getSelection().removeAllRanges();
    },
  },
};
</script>

<style></style>
